window.MultipleChoiceTestData = {
    // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
    "maxTries": Infinity,

    // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
    "reportScore": false,

    // Optional: Sollen die Fragen nicht durchgemischt werden?
    "keepOrder": false,

    // Optional: Wie soll bewertet werden?
    // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
    // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
    // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
    "countMode": "questions",

    // Wie viele Fragen sollen für einen Test gezogen werden?
    "questionsPerTest": 6,

    // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
    "threshold": 1,

    // Optional: Begrüßungstext
    "htmlIntro": "<p>Trage alle ablesbaren Nullstellen ein, um dieses Lernpaket erfolgreich abzuschließen. Achtung: Doppelte Nullstellen sind zugleich die kleinere und die größere Nullstelle.</p>",

    // Verfügbare Fragen
    "questions": [],

    // Fragengeneratoren
    "generators": []
};

(function(generators) {
    function addLinearFactor(x0, forceMinus) {
        if (forceMinus) {
            let s = (x0 < 0) ? '[' : '(';
            s += 'x - ';
            s += (x0 < 0) ? '(' : '';
            s += "<strong style=\"background-color:#fce94f\">";
            s += x0;
            s += "</strong>";
            s += (x0 < 0) ? ')]' : ')';
            return s;
        }
        if (x0 == 0)
            return 'x';
        return '(x ' + ((x0 < 0) ? '+ ' : '- ') + Math.abs(x0) + ')';
    }

    function addFrage(arrFragen, a, x1, x2) {
        if (Math.random() < 0.75)
            a *= (1 + Math.floor(Math.random() * 9));
        let raw_x1 = x1 * (1 + Math.floor(Math.random() * 9));
        let raw_x2 = x2 * (1 + Math.floor(Math.random() * 9));
        if ((Math.random() < 0.33) && x1)
            raw_x2 = x2 * Math.abs(raw_x1);
        x1 = Math.min(raw_x1, raw_x2);
        x2 = Math.max(raw_x1, raw_x2);
        const vorher = (Math.abs(a) == 1) ? ((a < 0) ? '-' : '') : (a + " ");
        const frage = {
            "html": "???",
            "keepOrder": true,
            "response" :'',
            "choices": [
                { "html": "Kleinere Nullstelle: ", "min": -10, "max": 10, "step": 1, "type": "number", "size": 2, "correct": true, "accept": x1, "response": "" },
                { "html": "Größere Nullstelle: ", "min": -10, "max": 10, "step": 1, "type": "number", "size": 2, "correct": true, "accept": x2, "response": "" }
            ]
        };
        let flip = (Math.random() < 0.5);
        let term = vorher + addLinearFactor(flip ? x2 : x1);
        term += (x1 == x2) ? '²' : addLinearFactor(flip ? x1 : x2);

        frage.html = "<p>Welche Nullstellen hat <code>f(x) = " + term + "</code>?</p>";
        if (x1 == x2) {
            frage.choices[0].response = "Doppelte Nullstelle <strong style=\"background-color:#fce94f\">" + x1 + "</strong> ist zugleich kleinere und größere Nullstelle";
            frage.choices[1].response = frage.choices[0].response;
        } else {
            frage.choices[0].response = "Kleinere Nullstelle: Nullstellen <strong style=\"background-color:#fce94f\">" + x1 + "</strong> &lt; " + x2;
            frage.choices[1].response = "Größere Nullstelle: Nullstellen " + x1 + " &lt; <strong style=\"background-color:#fce94f\">" + x2 + "</strong>";
        }
        frage.response = "<code>f(x) = " + term + " = " + a + " · " + addLinearFactor(flip ? x2 : x1, true) + ' · ' + addLinearFactor(flip ? x1 : x2, true);
        arrFragen.push(frage);
    }

    [-1, 0, +1].map(y_S => [-1, 0, +1].map(x_S => [-1, +1].map(a => generators.push(arrFragen => addFrage(arrFragen, a, x_S,  y_S)))));
})(window.MultipleChoiceTestData.generators);
